package com.sneeze.hb_test_flutter_plugin;

import android.os.Handler;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.BasicMessageChannel;
import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.plugin.common.StandardMessageCodec;

/** HbTestFlutterPlugin */
public class HbTestFlutterPlugin implements FlutterPlugin, MethodCallHandler, BasicMessageChannel.MessageHandler, EventChannel.StreamHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private BasicMessageChannel basicMessageChannel;
  private EventChannel eventChannel;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "hb_test_flutter_plugin");
    channel.setMethodCallHandler(this);

    basicMessageChannel = new BasicMessageChannel(flutterPluginBinding.getBinaryMessenger(), "hb_test_flutter_plugin_message", StandardMessageCodec.INSTANCE);
    basicMessageChannel.setMessageHandler(this);

    eventChannel = new EventChannel(flutterPluginBinding.getBinaryMessenger(), "hb_test_flutter_plugin_message_event");
    eventChannel.setStreamHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onMessage(@Nullable Object message, @NonNull BasicMessageChannel.Reply reply) {
    System.out.println("Receive Message from flutter:" + message.toString());
    reply.reply("Hello Flutter!");
  }



  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  @Override
  public void onListen(Object arguments, final EventChannel.EventSink events) {
    new Handler().postDelayed(new Runnable() {
      @Override
      public void run() {
        events.success("Hello Event Flutter!");
      }
    },3000);
  }

  @Override
  public void onCancel(Object arguments) {

  }
}
