
import 'dart:async';

import 'package:flutter/services.dart';

class HbTestFlutterPlugin {
  static const MethodChannel _channel =
      const MethodChannel('hb_test_flutter_plugin');
  static const BasicMessageChannel _basicMessageChannel = const BasicMessageChannel('hb_test_flutter_plugin_message', StandardMessageCodec());
  static const EventChannel _eventChannel = const EventChannel("hb_test_flutter_plugin_message_event");

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');

    final String reply = await _basicMessageChannel.send("Hello Native!");
    print("Receive message from native:$reply");

    _eventChannel.receiveBroadcastStream().listen((event) {
      print("Receive Event from native:$event");
    });

    return version;
  }
}
